﻿
/*
 * DFAlert 1.1.2
 */

using ff14bot.Enums;
using ff14bot.RemoteWindows;
using ff14bot.Helpers;
using ff14bot.Interfaces;
using ff14bot.Managers;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Media;
using System.Text;
using System.Threading.Tasks;
using ff14bot.AClasses;

namespace DFAlert
{
    public class DFAlert : BotPlugin
    {
        #region init
        public override string Author { get { return "Parrot"; } }
        public override string Description { get { return "Alerts user when DF group is ready"; } }
        public override Version Version { get { return new Version(1, 1, 2); } }

        public override string Name
        {
            get { return "DFAlert"; }
        }
        public override bool WantButton
        {
            get { return true; }
        }
        public override string ButtonText
        {
            get { return "Settings"; }
        }
        public override void OnButtonPress()
        {
            var sf = new settingsForm();
            sf.ShowDialog();

        }
        public override void OnEnabled()
        {
            Settings.load();            
            dutyJoiner = new DutyJoiner(); 
        }
        #endregion

        private bool isUp;
        private DutyJoiner dutyJoiner;

        public override void OnPulse()
        {
            if (ff14bot.Core.IsInGame)
                run();
        }
        private void run()
        {
            if (ContentsFinderConfirm.IsOpen)
            {
                if (!isUp)
                {
                    isUp = true;
                    SndPlayer.play();
                    Log.print("Dungeon is ready");
                    if(Settings.current.pBullet.active)
                        new PushBullet.Note("DfAlert", "Dungeon is ready").push();
                    dutyJoiner.reset();
                }
                if (Settings.current.autoCommence.active)
                    dutyJoiner.commence();
            }
            else            
                isUp = false;            
        }

        private class DutyJoiner
        {
            private DateTime joinTime;
            private bool isTimeSet;
            private bool commenced;

            public DutyJoiner()
            {
                isTimeSet = false;
                commenced = false;
            }

            public bool commence()
            {
                if(!isTimeSet)
                {
                    joinTime = DateTime.Now.Add(TimeSpan.FromSeconds(Settings.current.autoCommence.delay));
                    isTimeSet = true;
                }

                if(!commenced && DateTime.Now > joinTime && ContentsFinderConfirm.IsOpen)
                {
                    ContentsFinderConfirm.Commence();
                    commenced = true;
                    return true;
                }

                return false;
            }
            public void reset()
            {
                commenced = false;
                isTimeSet = false;
            }            
        }

        private static class SndPlayer
        {
            private const string fileName = "DungeonIsReady.wav";
            public static void play()
            {
                try
                {
                    SoundPlayer sp = new SoundPlayer();
                    sp.SoundLocation = System.Windows.Forms.Application.StartupPath + @"\Plugins\DFAlert\Sounds\"+fileName;
                    sp.Play();
                }
                catch (Exception e)
                {
                    Log.print("Error: Could not play audio.\n" + e.Message);
                }
            }
        }
    }
}




