﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Xml.Serialization;
using System.Windows.Media;
namespace DFAlert
{
    public static class Settings
    {
        public static Profile current = new Profile();
        public static bool save()
        {
            try
            {
                XmlSerializer serializer = new XmlSerializer(typeof(Profile));
                TextWriter textWriter = new StreamWriter(Application.StartupPath + @"\Plugins\DFAlert\Settings.xml");
                serializer.Serialize(textWriter, current);
                textWriter.Close();
            }
            catch (Exception e)
            {
                Log.print("Error while saving :\n" + e.Message);
                return false;
            }
            Log.print("Saved settings.", Colors.White);
            return true;
        }

        public static bool load()
        {
            try
            {
                XmlSerializer deserializer = new XmlSerializer(typeof(Profile));
                TextReader textReader = new StreamReader(Application.StartupPath + @"\Plugins\DFAlert\Settings.xml");
                current = (Profile)deserializer.Deserialize(textReader);
                textReader.Close();
            }
            catch (Exception e)
            {
                Log.print("Failed to load settings :\n" + e.Message);
                current = new Profile();
                return false;
            }

            Log.print("Settings loaded", Colors.White);
            return true;

        }

        public class Profile
        {
            public AutoCommence autoCommence;
            public PBullet pBullet;
            public Profile()
            {
                autoCommence = new AutoCommence();
                pBullet = new PBullet();
            }
        }
        public class AutoCommence
        {
            public bool active;
            public int delay; ///Seconds
            public AutoCommence()
            {
                active = false;
                delay = 20;
            }
        }

        public class PBullet
        {
            public bool active;
            public string token;

            public PBullet()
            {
                active = false;
                token = "";
            }
        }
    }
}
